#include <boost/lexical_cast.hpp>
#include "Nivel.h"


Nivel::Nivel (Gosu::Graphics& graphics, int nivel) : nivel_(nivel)
{
	switch(nivel)
	{
		case 1:
		{
			fondo_ = new Gosu::Image(graphics, L"../graficos/niveles/1/nivel_1_1_largo.png");
			music_ = new Gosu::Song(L"../audio/musica/fondo1.ogg");

			Enemigos_.push_back(new Abeja(graphics, 300, 450, 150));
			Enemigos_.push_back(new Abeja(graphics, 900, 1850, 150));
			Enemigos_.push_back(new Abeja(graphics, 1500, 1950, 165));
			Enemigos_.push_back(new Abeja(graphics, 3600, 3900, 250));
			
	//		Obstaculos_.push_back(new Obstaculo(graphics, new Gosu::Image(graphics, Gosu::sharedResourcePrefix() + L"../graficos/niveles/1/suelo.png"),0,10000,10000,SUELO_Y));

			Obstaculos_.push_back(new Basura(graphics, 800, 240));
			Obstaculos_.push_back(new Basura(graphics, 2800, 240));
			Obstaculos_.push_back(new Basura(graphics, 3600, 240));
			Obstaculos_.push_back(new Basura(graphics, 3800, 240));

			Obstaculos_.push_back(new Caja(graphics, 700, 350));
			Obstaculos_.push_back(new Caja(graphics, 2700, 350));
			Obstaculos_.push_back(new Caja(graphics, 3500, 350));
			Obstaculos_.push_back(new Caja(graphics, 3700, 350));

			Mosquitos_.push_back(new Mosquito(graphics, 600, 120));

			break;
		}
		default: break;
	}
}


Nivel::~Nivel ()
{
	delete fondo_;
}

void Nivel::draw (int x, int y, int z)
{
	fondo_->draw(x,y,z);
	music_->play();

   mover_enemigos(x);
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos().begin() ; i != Obstaculos().end() ; i++ )
	   (*i)->draw(x+(*i)->posX(),(*i)->posY(),1);
	   
	mover_mosquitos(x);
}

int Nivel::width() const
{
	return width_;
}


int Nivel::height() const
{
	return height_;
}


int Nivel::suelo() const // Lo he puesto por poner, al final lo quitaremos
{
	return suelo_;
}

int Nivel::nivel() const
{
	return nivel_;
}

Gosu::Image* Nivel::fondo() const
{
	return fondo_;
}

/*
Gosu::Song* Nivel::music()
{
	return music_;
}
*/

vector<Obstaculo*>::iterator Nivel::HayObstaculoDer(Aranya *minyimi)
{
   int aranyaX = minyimi->movX() + minyimi->posX() + minyimi->width();
   int aranyaYporarriba = minyimi->posY() + minyimi->height();
   int aranyaYporabajo = minyimi->posY();
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos_.begin() ; i != Obstaculos_.end() ; i++ )
		if ( aranyaX == (*i)->posX() and ( not ( aranyaYporarriba <= (*i)->posY() or aranyaYporabajo >= (*i)->posY() + (*i)->height() ) ) )
		   return i;
	
	return Obstaculos_.end();
}

vector<Obstaculo*>::iterator Nivel::HayObstaculoIzq(Aranya *minyimi)
{
   int aranyaX = minyimi->movX() + minyimi->posX();
   int aranyaYporarriba = minyimi->posY() + minyimi->height();
   int aranyaYporabajo = minyimi->posY();
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos_.begin() ; i != Obstaculos_.end() ; i++ )
	   if ( aranyaX == (*i)->posX() + (*i)->width() and ( not ( aranyaYporarriba <= (*i)->posY() or aranyaYporabajo >= (*i)->posY() + (*i)->height() ) ) )
		   return i;
	
	return Obstaculos_.end();
}


vector<Obstaculo*>::iterator Nivel::HayObstaculoArriba(Aranya *minyimi)
{
   int aranyaXporizq = minyimi->movX() + minyimi->posX() + minyimi->width();
   int aranyaXporder = minyimi->movX() + minyimi->posX();
   int aranyaY = minyimi->posY();
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos_.begin() ; i != Obstaculos_.end() ; i++ )
	   if ( aranyaY == (*i)->posY() + (*i)->height() and ( not ( aranyaXporizq <= (*i)->posX() or aranyaXporder >= (*i)->posX() + (*i)->width() ) ) )
		   return i;
	
	return Obstaculos_.end();
}


vector<Obstaculo*>::iterator Nivel::HayObstaculoAbajo(Aranya *minyimi)
{
   int aranyaXporizq = minyimi->movX() + minyimi->posX() + minyimi->width();
   int aranyaXporder = minyimi->movX() + minyimi->posX();
   int aranyaY = minyimi->posY() + minyimi->height();
   
   for ( vector<Obstaculo*>::iterator i = Obstaculos_.begin() ; i != Obstaculos_.end() ; i++ )
	   if ( aranyaY == (*i)->posY() and ( not ( aranyaXporizq <= (*i)->posX() or aranyaXporder >= (*i)->posX() + (*i)->width() ) ) )
		   return i;
		   
	return Obstaculos_.end();
}


bool Nivel::MuereMinyimiMuere(Aranya *minyimi)
{
	if ( !minyimi->muerta() )
	{
		for ( vector<Enemigo*>::iterator i = Enemigos_.begin() ; i != Enemigos_.end() ; i++ )
		{
			if ( ( minyimi->movX() + minyimi->posX() + minyimi->width() >= (*i)->posicion() and minyimi->movX() + minyimi->posX() + minyimi->width() <= (*i)->posicion() + (*i)->width() ) and ( not ( minyimi->posY() + minyimi->height() < (*i)->movY() or minyimi->posY() > (*i)->movY() + (*i)->height() ) ) )
			{
				minyimi->muerta(true);
			   return true;
			}
			else if ( ( minyimi->movX() + minyimi->posX() <= (*i)->posicion() + (*i)->width() and minyimi->movX() + minyimi->posX() >= (*i)->posicion() ) and ( not ( minyimi->posY() + minyimi->height() < (*i)->movY() or minyimi->posY() > (*i)->movY() + (*i)->height() ) ) )
			{
				minyimi->muerta(true);
			   return true;
			}
			else if ( ( minyimi->posY() <= (*i)->movY() + (*i)->height() and minyimi->posY() >= (*i)->movY() ) and ( not ( minyimi->movX() + minyimi->posX() + minyimi->width() < (*i)->posicion() or minyimi->movX() + minyimi->posX() > (*i)->posicion() + (*i)->width() ) ) )
			{
				minyimi->muerta(true);
			   return true;
			}
			else if ( ( minyimi->posY() + minyimi->height() >= (*i)->movY() and minyimi->posY() + minyimi->height() <= (*i)->movY() + (*i)->height() ) and ( not ( minyimi->movX() + minyimi->posX() + minyimi->width() < (*i)->posicion() or minyimi->movX() + minyimi->posX() > (*i)->posicion() + (*i)->width() ) ) )
			{
				minyimi->muerta(true);
			   return true;
			}
		}
		minyimi->muerta(false);
	}
   return false;
}



bool Nivel::Comida(Aranya *minyimi)
{
	if ( !minyimi->muerta() )
	{
		for ( vector<Mosquito*>::iterator i = Mosquitos_.begin() ; i != Mosquitos_.end() ; i++ )
		{
			if (! (*i)->muerto() )
			{
				if ( ( minyimi->movX() + minyimi->posX() + minyimi->width() >= (*i)->posX() and minyimi->movX() + minyimi->posX() + minyimi->width() <= (*i)->posX() + (*i)->width() ) and ( not ( minyimi->posY() + minyimi->height() < (*i)->posY() or minyimi->posY() > (*i)->posY() + (*i)->height() ) ) )
				{
					minyimi->come();
					(*i)->muerto(true);
					return true;
				}
				else if ( ( minyimi->movX() + minyimi->posX() <= (*i)->posX() + (*i)->width() and minyimi->movX() + minyimi->posX() >= (*i)->posX() ) and ( not ( minyimi->posY() + minyimi->height() < (*i)->posY() or minyimi->posY() > (*i)->posY() + (*i)->height() ) ) )
				{
					minyimi->come();
					(*i)->muerto(true);
					return true;
				}
				else if ( ( minyimi->posY() <= (*i)->posY() + (*i)->height() and minyimi->posY() >= (*i)->posY() ) and ( not ( minyimi->movX() + minyimi->posX() + minyimi->width() < (*i)->posX() or minyimi->movX() + minyimi->posX() > (*i)->posX() + (*i)->width() ) ) )
				{
					minyimi->come();
					(*i)->muerto(true);
					return true;
				}
				else if ( ( minyimi->posY() + minyimi->height() >= (*i)->posY() and minyimi->posY() + minyimi->height() <= (*i)->posY() + (*i)->height() ) and ( not ( minyimi->movX() + minyimi->posX() + minyimi->width() < (*i)->posX() or minyimi->movX() + minyimi->posX() > (*i)->posX() + (*i)->width() ) ) )
				{
					minyimi->come();
					(*i)->muerto(true);
					return true;
				}
			}
		}
	}
   return false;
}


vector<Obstaculo*>& Nivel::Obstaculos()
{
	return Obstaculos_;
}

vector<Enemigo*>& Nivel::Enemigos()
{
	return Enemigos_;
}

vector<Mosquito*>& Nivel::Mosquitos()
{
	return Mosquitos_;
}


void Nivel::mover_enemigos(int desplazamiento)
{
	for ( vector<Enemigo*>::iterator i = Enemigos().begin() ; i != Enemigos().end() ; i++ )
	{
		/// Avanzando hacia la derecha
		if((*i)->posicion() < (*i)->movX2() and (*i)->direccion() == 0)
		{
		   (*i)->control_der().second++;
			if((*i)->control_der().second % 500 != 0)
		   {
		      (*i)->control_der().first[(*i)->palader()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
		   }
		   else
			{
			   (*i)->palader();
			   (*i)->control_der().first[(*i)->palader()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			(*i)->posicion((*i)->velX());
		}
		
		/// Girando en el rango máximo, de derecha a izquierda   
		if((*i)->posicion() >= (*i)->movX2() and (*i)->direccion() == 0)
		{
			(*i)->posicion(-(*i)->velX());
			(*i)->control_izq().second++;
			if((*i)->control_izq().second % 500 != 0)
			{
			   int draw_x = desplazamiento+(*i)->posicion();
			   int draw_y = (*i)->movY();
			   int cambio_de_imagen = (*i)->palaizq();
			   (*i)->control_izq().first[cambio_de_imagen]->draw(draw_x,draw_y,1);
			}
			else
			{
			   (*i)->palaizq();
			   (*i)->control_izq().first[(*i)->palaizq()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			(*i)->direccion(1);
		}
		

		/// Retrocediendo hacia la izquierda
		if((*i)->posicion() > (*i)->movX1() and (*i)->direccion() == 1)
		{
			(*i)->control_izq().second++;
			if((*i)->control_izq().second % 500 != 0)
			{
				(*i)->control_izq().first[(*i)->palaizq()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			else
			{
				(*i)->palaizq();
				(*i)->control_izq().first[(*i)->palaizq()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			(*i)->posicion(-(*i)->velX());
		}
		

		/// Girando en el rango mínimo, de izquierda a derecha   
		if((*i)->posicion() <= (*i)->movX1() and (*i)->direccion() == 1)
		{
		   (*i)->posicion((*i)->velX());
			(*i)->control_der().second++;
			if((*i)->control_der().second % 500 != 0)
			{
				(*i)->control_der().first[(*i)->palader()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			else
			{
				(*i)->palader();
				(*i)->control_der().first[(*i)->palader()]->draw(desplazamiento+(*i)->posicion(),(*i)->movY(),1);
			}
			(*i)->direccion(0);
		} 
	}
}


void Nivel::mover_mosquitos(int desplazamiento)
{
	for ( vector<Mosquito*>::iterator i = Mosquitos().begin() ; i != Mosquitos().end() ; i++ )
	{
		(*i)->mover().second = ((*i)->mover().second+1) % 10;
 		if ( (*i)->mover().second == 0 )
 		   (*i)->mover().first = ((*i)->mover().first+1) % 2;
		
		if ( !(*i)->muerto() )
	   	(*i)->draw ( desplazamiento + (*i)->posX() , (*i)->posY() , 1 );
	}
}



Menu::Menu (Gosu::Graphics& graphics)
{
	fondo_ = new Gosu::Image(graphics, L"../graficos/fondo_menu.png");
   bjugar1_ = new Gosu::Image(graphics, L"../graficos/botones/bjugar1.png");
   bjugar2_ = new Gosu::Image(graphics, L"../graficos/botones/bjugar2.png");
   bsalir1_ = new Gosu::Image(graphics, L"../graficos/botones/bsalir1.png");
   bsalir2_ = new Gosu::Image(graphics, L"../graficos/botones/bsalir2.png");
   music_ = new Gosu::Song(L"../audio/musica/inicial.ogg");
	nivel11_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel11.png");
	nivel12_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel12.png");
	nivel21_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel21.png");
	nivel22_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel22.png");
	nivel31_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel31.png");
	nivel32_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel32.png");
	nivel41_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel41.png");
	nivel42_ = new Gosu::Image(graphics, L"../graficos/botones/bnivel42.png");
}



Menu::~Menu()
{
	delete fondo_;
	delete bjugar1_;
	delete bjugar2_;
	delete bsalir1_;
	delete bsalir2_;
	delete music_;
	delete nivel11_;
	delete nivel12_;
	delete nivel21_;
	delete nivel22_;
	delete nivel31_;
	delete nivel32_;
	delete nivel41_;
	delete nivel42_;
}


void Menu::draw(double x, double y)
{
   fondo_->draw(0,0,0);
   
   if ( x >= 650 and x <= 650 + 110 and y >= 100 and y <= 100 + 110 )
	   bjugar2_->draw(650,100,1);
	else
		bjugar1_->draw(650,100,1);
   
   if ( x >= 650 and x <= 650 + 110 and y >= 350 and y <= 350 + 110 )
	   bsalir2_->draw(650,350,1);
   else
		bsalir1_->draw(650,350,1);
   
   music_->play();
}

void Menu::pararMusica()
{
	music_->play();
}

void Menu::niveles(double x, double y)
{
   fondo_->draw(0,0,0);
   
   if ( x >= 250 and x <= 250 + 300 and y >= 70 and y <= 70 + 65 )
		nivel12_->draw(250,70,2);
	else
		nivel11_->draw(250,70,2);

   if ( x >= 250 and x <= 250 + 300 and y >= 150 and y <= 150 + 65 )
		nivel22_->draw(250,150,2);
   else
		nivel21_->draw(250,150,2);
	   
   if ( x >= 250 and x <= 250 + 300 and y >= 230 and y <= 230 + 65 )
		nivel32_->draw(250,230,2);
   else
		nivel31_->draw(250,230,2);
	   
   if ( x >= 250 and x <= 250 + 300 and y >= 310 and y <= 310 + 65 )
		nivel42_->draw(250,310,2);
   else
		nivel41_->draw(250,310,2);
}

int Menu::escogernivel(int ratonX, int ratonY)
{
   int eleccion = 0;
   if(ratonX >= 250 and ratonX <= 549 and ratonY >= 70 and ratonY <= 137)
		eleccion = 1;
// 		setCaption(L"Coherencia Zer0 - Level 1 : El Comienzo");
   else if(ratonX >= 250 and ratonX <= 549 and ratonY >= 150 and ratonY <= 217)
	   eleccion = 2;
   else if(ratonX >= 250 and ratonX <= 549 and ratonY >= 230 and ratonY <= 297)
	   eleccion = 3;
	else if(ratonX >= 250 and ratonX <= 549 and ratonY >= 310 and ratonY <= 377)
	   eleccion = 4;
	return eleccion;
}

