#include <boost/lexical_cast.hpp>
#include "Ventana.h"

Ventana::Ventana() : Gosu::Window(800,500,false)
{
   setCaption(L"Coherencia Zer0");
   
   modo_=0;
   
   image_pause_ = new Gosu::Image(graphics(), L"../graficos/pausa.png");
   pause_ = false;
   nivelelegido_ = -1;
   nivel = new Nivel(graphics(),1); // Esto se tiene que hacer aquí? 
   menu = new Menu(graphics());
   minyimi = new Aranya(graphics());
}

Ventana::~Ventana()
{
   if (nivelelegido_ > 0)
      delete nivel;
   delete menu;
}

void Ventana::update()
{
   if(modo_ == 1)
   {
   	if(!pause_)
   	{
			if ( nivel->Comida(minyimi) )
			{
				minyimi->sonidoComida();
			}

			if ( minyimi->muerta() )
			{
		
			}
			
			/* ARRIBA + DERECHA */
			else if( !minyimi->saltando() and input().down(Gosu::kbUp) and input().down(Gosu::kbRight) and !input().down(Gosu::kbLeft) and nivel->HayObstaculoArriba(minyimi) == nivel->Obstaculos().end() and nivel->HayObstaculoDer(minyimi) == nivel->Obstaculos().end() and (minyimi->posY() == SUELO_Y or nivel->HayObstaculoAbajo(minyimi) != nivel->Obstaculos().end()) )
			{ 
			   minyimi->sonidoSalto();
		 		minyimi->movX(VELOCIDAD_MINYIMI);

		 		minyimi->saltando() = true;
			 	minyimi->direccion() = 2;
			}


			/* ARRIBA + IZQUIERDA */
			else if( !minyimi->saltando() and input().down(Gosu::kbUp) and !input().down(Gosu::kbRight) and input().down(Gosu::kbLeft) and nivel->HayObstaculoArriba(minyimi) == nivel->Obstaculos().end() and nivel->HayObstaculoIzq(minyimi) == nivel->Obstaculos().end() and (minyimi->posY() == SUELO_Y or nivel->HayObstaculoAbajo(minyimi) != nivel->Obstaculos().end()) )
			{
				minyimi->sonidoSalto();
			 	minyimi->movX(-VELOCIDAD_MINYIMI);

		 		minyimi->saltando() = true;
			 	minyimi->direccion() = 3;

			}
	
			/* DERECHA */
			else if ( input().down(Gosu::kbRight) and !input().down(Gosu::kbLeft) and nivel->HayObstaculoDer(minyimi) == nivel->Obstaculos().end() )
			{
		 		minyimi->movX(VELOCIDAD_MINYIMI);
		 		
		 		if ( minyimi->saltando() )
		 		   minyimi->direccion() = 2;
		 		else
		 		{
		 			minyimi->md().second = (minyimi->md().second+1) % 5;
			 		if ( minyimi->md().second == 0 )
			 		   minyimi->md().first = (minyimi->md().first+1) % 5;
			 	
			 		minyimi->direccion() = 0;
		 		}
			}
			
			/* IZQUIERDA */
			else if ( input().down(Gosu::kbLeft) and !input().down(Gosu::kbRight) and nivel->HayObstaculoIzq(minyimi) == nivel->Obstaculos().end() )
			{
			   minyimi->movX(-VELOCIDAD_MINYIMI);

		 		if ( minyimi->saltando() )
		 			minyimi->direccion() = 3;
		 	   else
		 		{
		 		   minyimi->mi().second = (minyimi->mi().second+1) % 5;
			 		if ( minyimi->mi().second == 0 )
			 		   minyimi->mi().first = (minyimi->mi().first+1) % 5;
					minyimi->direccion() = 1;
		 		}
		 		
			}
		   
		   /* ARRIBA */
		   else if ( !minyimi->saltando() and input().down(Gosu::kbUp) and !input().down(Gosu::kbRight) and !input().down(Gosu::kbLeft) and nivel->HayObstaculoArriba(minyimi) == nivel->Obstaculos().end() and (minyimi->posY() == SUELO_Y or nivel->HayObstaculoAbajo(minyimi) != nivel->Obstaculos().end()) )
		   {
				minyimi->sonidoSalto();
		 		minyimi->saltando() = true;
		 		
			 	if ( minyimi->direccion() == 0 )
				   minyimi->direccion() = 2;
				else if ( minyimi->direccion() == 1 )
				   minyimi->direccion() = 3;
		   }

			else if ( !minyimi->saltando() )
			{
				if (minyimi->direccion() == 2)
					minyimi->direccion() = 0;
				else if (minyimi->direccion() == 3)
					minyimi->direccion() = 1;
			}
		}
   }
}

void Ventana::draw()
{
   if(modo_ == 0)
   {
		menu->draw(input().mouseX(),input().mouseY());
	}
   
   else if (pause_)
   {
      nivel->fondo()->draw(-minyimi->movX(),0,0);
      image_pause_->draw(0,0,1);
   }
   
   else if(modo_ == 1 && nivelelegido_ == 0)
   {
// 	   Gosu::Button B;
    	menu->niveles(input().mouseX(),input().mouseY());
      image_pause_->draw(0,0,1);
// 		if(B == Gosu::msLeft)
//       {
//          int ratonX = input().mouseX();
//          int ratonY = input().mouseY();
// 		   nivelelegido_ = menu->escogernivel(ratonX,ratonY);
// 		   nivel = new Nivel(graphics(),nivelelegido_);
// 		}
	}
	
	else if(modo_ == 1 && nivelelegido_ > 0)
   {
	   bool obstabajo=0;
		if(minyimi->muerta() or nivel->MuereMinyimiMuere(minyimi))
		{
		   Gosu::Image *pobreminyimi = new Gosu::Image(graphics(), L"../graficos/aranya/muerta.png");
			if(minyimi->posY() != SUELO_Y && nivel->HayObstaculoAbajo(minyimi) == nivel->Obstaculos().end())
				minyimi->movY(5);
			pobreminyimi->draw(minyimi->posX(),minyimi->posY(),2);
			// delete?
		}
   	else if(minyimi->direccion() == 0)
		{
			if(minyimi->posY() != SUELO_Y && nivel->HayObstaculoAbajo(minyimi) == nivel->Obstaculos().end())
				minyimi->movY(10);
			minyimi->movder()[minyimi->md().first]->draw(minyimi->posX(),minyimi->posY(),2);
		}
      else if(minyimi->direccion() == 1)
		{ 
			if(minyimi->posY() != SUELO_Y && nivel->HayObstaculoAbajo(minyimi) == nivel->Obstaculos().end())
				minyimi->movY(10);
			minyimi->movizq()[minyimi->mi().first]->draw(minyimi->posX(),minyimi->posY(),2);
		}
     	
     	else if(minyimi->direccion() == 2)
     	{
  			minyimi->ma().second = (minyimi->ma().second+1) % 10;
	 		if ( minyimi->ma().second == 0 )
	 		   minyimi->ma().first = (minyimi->ma().first+1) % 3;
			
			if ( minyimi->ma().first < 1 or ( minyimi->ma().first == 1 and minyimi->ma().second <= 4 ) )
			   minyimi->movY(SALTO_MINYIMI);
			else if(nivel->HayObstaculoAbajo(minyimi) == nivel->Obstaculos().end())
			   minyimi->movY(-SALTO_MINYIMI);
			else
			{
			   obstabajo = 1;
			   minyimi->movder()[minyimi->md().first]->draw(minyimi->posX(),minyimi->posY(),2);
			}
			
			if(!obstabajo)
				minyimi->mova()[minyimi->ma().first]->draw(minyimi->posX(),minyimi->posY(),2);
		  	
		  	if ( minyimi->ma().first == 0 and minyimi->ma().second == 0 )
		  	{
		  	   minyimi->saltando() = false;
		  	   minyimi->direccion() = 0;
		  	}
     	}
     	
     	else if(minyimi->direccion() == 3)
     	{
  			minyimi->ma().second = (minyimi->ma().second+1) % 10;
	 		if ( minyimi->ma().second == 0 )
	 		   minyimi->ma().first = (minyimi->ma().first+1) % 3;
			
			if ( minyimi->ma().first < 1 or ( minyimi->ma().first == 1 and minyimi->ma().second <= 4 ) )
			   minyimi->movY(SALTO_MINYIMI);
			else if(nivel->HayObstaculoAbajo(minyimi) == nivel->Obstaculos().end())
			   minyimi->movY(-SALTO_MINYIMI);
			else
			{
			   obstabajo = 1;
			   minyimi->movizq()[minyimi->mi().first]->draw(minyimi->posX(),minyimi->posY(),2);
			}
			
			if(!obstabajo)
				minyimi->mova()[minyimi->ma().first+3]->draw(minyimi->posX(),minyimi->posY(),2);
		  	
		  	if ( minyimi->ma().first == 0 and minyimi->ma().second == 0 )
		  	{
		  	   minyimi->saltando() = false;
		  	   minyimi->direccion() = 1;
		  	}
     	}
         
      nivel->draw(-minyimi->movX(),0,0);  
   }
}

void Ventana::buttonDown(Gosu::Button B)
{
   if(modo_ == 0)
      EleccionMenu(B);
   else if(modo_ == 1 and nivelelegido_ == 0)
	   EleccionNivel(B);
   else if(modo_ == 1 and nivelelegido_ > 0)
   {
      if(minyimi->muerta())
		{
			modo_ = 0;
			minyimi->reiniciarValores();
		}
		else if ( B == Gosu::kbP )
      {
      	pause_ = !pause_;
      }
   }
}

bool Ventana::needsCursor() const
{
   return true;
}

void Ventana::EleccionMenu(Gosu::Button B)
{
   if(B == Gosu::kbEnter)
   {
   	modo_=1;
		nivelelegido_ = 0;
		draw();
   }
   
   else if(B == Gosu::kbEscape)
   	close();
      
   else if(B == Gosu::msLeft)
   {
      int ratonX = input().mouseX();
      int ratonY = input().mouseY();
      if(ratonX >= 650 and ratonX <= 800 and ratonY >= 100 and ratonY <= 217)
      {
 			modo_=1;
			nivelelegido_ = 0;
			draw();
      }
      else if(ratonX >= 650 and ratonX <= 800 and ratonY >= 350 and ratonY <= 455)
	   	close();
   }
}

void Ventana::EleccionNivel(Gosu::Button B)
{
   if(B == Gosu::msLeft)
   {
      int ratonX = input().mouseX();
      int ratonY = input().mouseY();
      nivelelegido_ = menu->escogernivel(ratonX,ratonY);
	   nivel = new Nivel(graphics(),nivelelegido_); // Hay que hacer un delete en algún sitio
		menu->pararMusica();
		switch(nivelelegido_)
		{
		  case 1:
		  {
			 setCaption(L"Coherencia Zer0 - Level 1 : El Comienzo");
			 break;
		  }
		  case 2:
		  {
			 setCaption(L"Coherencia Zer0 - Level 2 : Hall");
			 break;
		  }
		  case 3:
		  {
			 setCaption(L"Coherencia Zer0 - Level 3 : Cocina");
			 break;
		  }
		  case 4:
		  {
			 setCaption(L"Coherencia Zer0 - Level 4 : Ático");
			 break;
		  }
		}
	}
}

int Ventana::width()
{
   return width_;
}


int Ventana::height()
{
   return height_;
}

