#ifndef VENTANA_H
#define VENTANA_H

#include <Gosu/Gosu.hpp>
//#include <Gosu/AutoLink.hpp> Este es para Windows
#include "Aranya.h"
#include "Enemigo.h"
#include "Obstaculo.h"
#include "Nivel.h"
#include <vector>
#include <iostream>

using namespace std;

/// @brief Clase Ventana.
///
/// Esta clase servirá para realizar la ventana donde se ejecutará el juego.
/// @author Rodríguez Quirós, Estefanía
/// @author Roy Castillo, Ester
/// @author Ruso Amieva, Antonio
/// @version 0.1

class Ventana: public Gosu::Window{
   public:
      /// @brief Crea una ventana para jugar.
      /// @return Objeto inicializado de la clase Ventana.
      Ventana();
		/// @brief Elimina un objeto Ventana y libera su espacio en memoria. 
      ~Ventana();
      /// @brief Actualiza la ventana.
      /// @return Modifica el objeto de la clase Ventana.
      void update();
      /// @brief Dibuja en la ventana.
      /// @return Dibuja en el objeto de la clase Ventana.
      void draw();
      /// @brief Capta las teclas pulsadas.
      /// @return Interpreta la tecla pulsada.
      void buttonDown(Gosu::Button B);
		/// @brief Permite mostrar o no el cursor durante el juego.
		/// @return True si el cursor se muestra y false en el caso contrario.
      bool needsCursor()const;
		/// @brief Trata la opción elegia en el menú principal.
      void EleccionMenu(Gosu::Button B);
		void EleccionNivel(Gosu::Button B);
		/// @brief Devuelve el ancho de la ventana.
		/// @return Atributo width_, donde se incluye el ancho del objeto.
      int width();
		/// @brief Devuelve el alto de la ventana.
		/// @return Atributo height_, donde se incluye el alto del objeto.
      int height();
		/// @brief Mueve a los enemigos en el nivel.

            
   private:
      int modo_,nivelelegido_;
		/// @name ProporcionesVentana
      int width_,height_;
		/// @ }
      Gosu::Image *image_pause_;
      bool pause_;
      
      Aranya *minyimi;
      Menu *menu;
      Nivel *nivel;
};

#endif

